<template>
  <div>
    <span class="q-mt-xl page-header"> {{ t('loginHeader') }} </span>
    <p class="page-subtitle">{{ t('loginSubtitle') }}</p>

    <q-form class="column q-mt-l" @submit.prevent="handleLogin">
      <q-input v-model="emailInput" class="q-mb-md" :label="t('emailInputLabel')"
        :rules="[(val) => val.length > 0 || t('emailInputEmptyRule')]">
        <template #prepend>
          <q-icon name="mail_outline" />
        </template>
      </q-input>

      <q-input v-model="usernameInput" class="q-mb-md" :label="t('usernameInputLabel')"
        :rules="[(val) => val.length > 0 || t('usernameInputEmptyRule')]">
        <template #prepend>
          <q-icon name="person_outline" />
        </template>
      </q-input>

      <q-input v-model="passwordInput" :label="t('passwordInputLabel')" :type="isVisible ? 'text' : 'password'"
        :rules="[(val) => val.length > 0 || t('passwordInputEmptyRule')]">
        <template #prepend>
          <q-icon name="lock_outline" />
        </template>

        <template #append>
          <q-icon :name="isVisible ? 'visibility_off' : 'visibility'" class="cursor-pointer"
            @click="isVisible = !isVisible" />
        </template>
      </q-input>

      <q-btn no-caps dense rounded flat class="self-end" style="width: fit-content">
        {{ t('forgotPasswordLabel') }}
      </q-btn>

      <q-btn rounded class="q-mt-md" padding="md" type="submit" :disabled="isLoading">
        {{ t('signInLabel') }}
      </q-btn>
    </q-form>

    <q-space></q-space>

    <!-- <div class="q-my-lg flex-center row">
      <span> {{ t('noAccountLabel') }} </span>
      <q-btn rounded flat dense no-caps to="/register">
        {{ t('signUpLabel') }}!
      </q-btn>
    </div> -->
  </div>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { useI18n } from 'vue-i18n';
import { useRouter } from 'vue-router';
import { useAuth } from '../hooks/auth';

const { t } = useI18n();

const router = useRouter();
const { isLoading, error, login } = useAuth();

const emailInput = ref<string>('');
const passwordInput = ref<string>('');
const usernameInput = ref<string>('');

const isVisible = ref<boolean>(false);

const handleLogin = async () => {
  const response = await login({
    email: emailInput.value,
    password: passwordInput.value,
    username: usernameInput.value,
  });

  if (!error.value && response) {
    router.push('/');
  } else {
    console.error(error.value);
  }
};
</script>
